scala.collection.immutable.IndexedSeq

# Impl

###
Related Doc: package IndexedSeq

#### class Impl[A] extends AbstractSeq[A] with IndexedSeq[A] with Serializable

Source
  IndexedSeq.scala

Linear Supertypes
Serializable, java.io.Serializable, IndexedSeq[A], collection.IndexedSeq[A], IndexedSeqLike[A, IndexedSeq[A]], Seq[A], Iterable[A], Traversable[A], Immutable, AbstractSeq[A], collection.Seq[A], SeqLike[A, IndexedSeq[A]], GenSeq[A], GenSeqLike[A, IndexedSeq[A]], PartialFunction[Int, A], (Int) ⇒ A, AbstractIterable[A], collection.Iterable[A], IterableLike[A, IndexedSeq[A]], Equals, GenIterable[A], GenIterableLike[A, IndexedSeq[A]], AbstractTraversable[A], collection.Traversable[A], GenTraversable[A], GenericTraversableTemplate[A, IndexedSeq], TraversableLike[A, IndexedSeq[A]], GenTraversableLike[A, IndexedSeq[A]], Parallelizable[A, ParSeq[A]], TraversableOnce[A], GenTraversableOnce[A], FilterMonadic[A, IndexedSeq[A]], HasNewBuilder[A, scala.collection.immutable.IndexedSeq[A] @scala.annotation.unchecked.uncheckedVariance], AnyRef, Any
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Impl
2. Serializable
3. Serializable
4. IndexedSeq
5. IndexedSeq
6. IndexedSeqLike
7. Seq
8. Iterable
9. Traversable
10. Immutable
11. AbstractSeq
12. Seq
13. SeqLike
14. GenSeq
15. GenSeqLike
16. PartialFunction
17. Function1
18. AbstractIterable
19. Iterable
20. IterableLike
21. Equals
22. GenIterable
23. GenIterableLike
24. AbstractTraversable
25. Traversable
26. GenTraversable
27. GenericTraversableTemplate
28. TraversableLike
29. GenTraversableLike
30. Parallelizable
31. TraversableOnce
32. GenTraversableOnce
33. FilterMonadic
34. HasNewBuilder
35. AnyRef
36. Any

Implicitly

1. by SeqCharSequence
2. by CollectionsHaveToParArray
3. by MonadOps
4. by any2stringadd
5. by StringFormat
6. by Ensuring
7. by ArrowAssoc
8. by alternateImplicit

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1. #### new Impl(buf: ArrayBuffer[A])

### Type Members

1. #### class Elements extends AbstractIterator[A] with BufferedIterator[A] with Serializable

   The class of the iterator returned by the `iterator` method.

   The class of the iterator returned by the `iterator` method. multiple `take`, `drop`, and `slice` operations on this iterator are bunched together for better efficiency.

   Attributes
     protected
   Definition Classes
     IndexedSeqLike
   Annotations
     @SerialVersionUID()

2. #### type Self = IndexedSeq[A]

   The type implementing this traversable

   The type implementing this traversable

   Attributes
     protected[this]
   Definition Classes
     TraversableLike

3. #### class WithFilter extends FilterMonadic[A, Repr]

   A class supporting filtered operations.

   A class supporting filtered operations. Instances of this class are returned by method `withFilter`.

   Definition Classes
     TraversableLike

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Impl[A] to any2stringadd[Impl[A]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ++[B](that: GenTraversableOnce[B]): IndexedSeq[B]

   [use case] Returns a new immutable sequence containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new immutable sequence containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the immutable sequence is the most specific superclass encompassing the element types of the two operands.

   Example:

       scala> val a = List(1)
       a: List[Int] = List(1)

       scala> val b = List(2)
       b: List[Int] = List(2)

       scala> val c = a ++ b
       c: List[Int] = List(1, 2)

       scala> val d = List('a')
       d: List[Char] = List(a)

       scala> val e = c ++ d
       e: List[AnyVal] = List(1, 2, a)

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new immutable sequence which contains all elements of this immutable sequence followed by all elements of `that`.

   Definition Classes
     TraversableLike → GenTraversableLike
   Full Signature

   #### def ++[B >: A, That](that: GenTraversableOnce[B])(implicit bf: CanBuildFrom[IndexedSeq[A], B, That]): That

5. #### def ++:[B >: A, That](that: collection.Traversable[B])(implicit bf: CanBuildFrom[IndexedSeq[A], B, That]): That

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one. Mnemonic: the COLon is on the side of the new COLlection type.

   Example:

       scala> val x = List(1)
       x: List[Int] = List(1)

       scala> val y = LinkedList(2)
       y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

       scala> val z = x ++: y
       z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   This overload exists because: for the implementation of `++:` we should reuse that of `++` because many collections override it with more efficient versions.

   Since `TraversableOnce` has no `++` method, we have to implement that directly, but `Traversable` and down can use the overload.

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this traversable collection followed by all elements of `that`.

   Definition Classes
     TraversableLike

6. #### def ++:[B](that: TraversableOnce[B]): IndexedSeq[B]

   [use case] As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   [use case]

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one. Mnemonic: the COLon is on the side of the new COLlection type.

   Example:

       scala> val x = List(1)
       x: List[Int] = List(1)

       scala> val y = LinkedList(2)
       y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

       scala> val z = x ++: y
       z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new immutable sequence which contains all elements of this immutable sequence followed by all elements of `that`.

   Definition Classes
     TraversableLike
   Full Signature

   #### def ++:[B >: A, That](that: TraversableOnce[B])(implicit bf: CanBuildFrom[IndexedSeq[A], B, That]): That

7. #### def +:(elem: A): IndexedSeq[A]

   [use case] A copy of the immutable sequence with an element prepended.

   [use case]

   A copy of the immutable sequence with an element prepended.

   Note that :-ending operators are right associative (see example). A mnemonic for `+:` vs. `:+` is: the COLon goes on the COLlection side.

   Also, the original immutable sequence is not modified, so you will want to capture the result.

   Example:

       scala> val x = List(1)
       x: List[Int] = List(1)

       scala> val y = 2 +: x
       y: List[Int] = List(2, 1)

       scala> println(x)
       List(1)

   elem

     the prepended element

   returns

     a new immutable sequence consisting of `elem` followed by all elements of this immutable sequence.

   Definition Classes
     SeqLike → GenSeqLike
   Full Signature

   #### def +:[B >: A, That](elem: B)(implicit bf: CanBuildFrom[IndexedSeq[A], B, That]): That

8. #### def ->[B](y: B): (Impl[A], B)

   Implicit information
     This member is added by an implicit conversion from Impl[A] to ArrowAssoc[Impl[A]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

9. #### def /:[B](z: B)(op: (B, A) ⇒ B): B

   Applies a binary operator to a start value and all elements of this traversable or iterator, going left to right.

   Applies a binary operator to a start value and all elements of this traversable or iterator, going left to right.

   Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

       scala> val a = List(1,2,3,4)
       a: List[Int] = List(1, 2, 3, 4)

       scala> val b = (5 /: a)(_+_)
       b: Int = 15

       scala> val c = (5 /: a)((x,y) => x + y)
       c: Int = 15

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

   B

     the result type of the binary operator.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this traversable or iterator, going left to right with the start value `z` on the left:

         op(...op(op(z, x_1), x_2), ..., x_n)

     where `x1, ..., xn` are the elements of this traversable or iterator.

   Definition Classes
     TraversableOnce → GenTraversableOnce

10. #### def :+(elem: A): IndexedSeq[A]

    [use case] A copy of this immutable sequence with an element appended.

    [use case]

    A copy of this immutable sequence with an element appended.

    A mnemonic for `+:` vs. `:+` is: the COLon goes on the COLlection side.

    Example:

        scala> val a = List(1)
        a: List[Int] = List(1)

        scala> val b = a :+ 2
        b: List[Int] = List(1, 2)

        scala> println(a)
        List(1)

    elem

      the appended element

    returns

      a new immutable sequence consisting of all elements of this immutable sequence followed by `elem`.

    Definition Classes
      SeqLike → GenSeqLike
    Full Signature

    #### def :+[B >: A, That](elem: B)(implicit bf: CanBuildFrom[IndexedSeq[A], B, That]): That

11. #### def :\[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this traversable or iterator and a start value, going right to left.

    Applies a binary operator to all elements of this traversable or iterator and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

        scala> val a = List(1,2,3,4)
        a: List[Int] = List(1, 2, 3, 4)

        scala> val b = (a :\ 5)(_+_)
        b: Int = 15

        scala> val c = (a :\ 5)((x,y) => x + y)
        c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this traversable or iterator, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

12. #### final def ==(arg0: Any): Boolean

    The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

    The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

13. #### def addString(b: StringBuilder): StringBuilder

    Appends all elements of this traversable or iterator to a string builder.

    Appends all elements of this traversable or iterator to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator without any separator string.

    Example:

        scala> val a = List(1,2,3,4)
        a: List[Int] = List(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> val h = a.addString(b)
        h: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

14. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this traversable or iterator to a string builder using a separator string.

    Appends all elements of this traversable or iterator to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator, separated by the string `sep`.

    Example:

        scala> val a = List(1,2,3,4)
        a: List[Int] = List(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> a.addString(b, ", ")
        res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

15. #### def addString(b: StringBuilder, start: String, sep: String, end: String): StringBuilder

    Appends all elements of this traversable or iterator to a string builder using start, end, and separator strings.

    Appends all elements of this traversable or iterator to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator are separated by the string `sep`.

    Example:

        scala> val a = List(1,2,3,4)
        a: List[Int] = List(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> a.addString(b , "List(" , ", " , ")")
        res5: StringBuilder = List(1, 2, 3, 4)

    b

      the string builder to which elements are appended.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

16. #### def aggregate[B](z: ⇒ B)(seqop: (B, A) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It is similar to `foldLeft` in that it doesn't require the result to be a supertype of the element type. In addition, it allows parallel collections to be processed in chunks, and then combines the intermediate results.

    `aggregate` splits the traversable or iterator into partitions and processes each partition by sequentially applying `seqop`, starting with `z` (like `foldLeft`). Those intermediate results are then combined by using `combop` (like `fold`). The implementation of this operation may operate on an arbitrary number of collection partitions (even 1), so `combop` may be invoked an arbitrary number of times (even 0).

    As an example, consider summing up the integer values of a list of chars. The initial value for the sum is 0. First, `seqop` transforms each input character to an Int and adds it to the sum (of the partition). Then, `combop` just needs to sum up the intermediate results of the partitions:

        List('a', 'b', 'c').aggregate(0)({ (sum, ch) => sum + ch.toInt }, { (p1, p2) => p1 + p2 })

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation) and may be evaluated more than once

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

17. #### def andThen[C](k: (A) ⇒ C): PartialFunction[Int, C]

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    C

      the result type of the transformation function.

    k

      the transformation function

    returns

      a partial function with the same domain as this partial function, which maps arguments `x` to `k(this(x))`.

    Definition Classes
      PartialFunction → Function1

18. #### def apply(idx: Int): A

    Selects an element by its index in the immutable sequence.

    Selects an element by its index in the immutable sequence.

    Example:

        scala> val x = List(1, 2, 3, 4, 5)
        x: List[Int] = List(1, 2, 3, 4, 5)

        scala> x(3)
        res1: Int = 4

    idx

      The index to select.

    returns

      the element of this immutable sequence at index `idx`, where `0` indicates the first element.

    Definition Classes
      Impl → SeqLike → GenSeqLike → Function1
    Exceptions thrown

      `IndexOutOfBoundsException` if `idx` does not satisfy `0 <= idx < length`.

19. #### def applyOrElse[A1 <: Int, B1 >: A](x: A1, default: (A1) ⇒ B1): B1

    Applies this partial function to the given argument when it is contained in the function domain.

    Applies this partial function to the given argument when it is contained in the function domain. Applies fallback function where this partial function is not defined.

    Note that expression `pf.applyOrElse(x, default)` is equivalent to

        if(pf isDefinedAt x) pf(x) else default(x)

    except that `applyOrElse` method can be implemented more efficiently. For all partial function literals the compiler generates an `applyOrElse` implementation which avoids double evaluation of pattern matchers and guards. This makes `applyOrElse` the basis for the efficient implementation for many operations and scenarios, such as:

    - combining partial functions into `orElse`/`andThen` chains does not lead to excessive `apply`/`isDefinedAt` evaluation
    - `lift` and `unlift` do not evaluate source functions twice on each invocation
    - `runWith` allows efficient imperative-style combining of partial functions with conditionally applied actions

    For non-literal partial function classes with nontrivial `isDefinedAt` method it is recommended to override `applyOrElse` with custom implementation that avoids double `isDefinedAt` evaluation. This may result in better performance and more predictable behavior w.r.t. side effects.

    x

      the function argument

    default

      the fallback function

    returns

      the result of this function or fallback function application.

    Definition Classes
      PartialFunction
    Since

      2.10

20. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

21. #### def canEqual(that: Any): Boolean

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    that

      The object with which this iterable collection should be compared

    returns

      `true`, if this iterable collection can possibly equal `that`, `false` otherwise. The test takes into consideration only the run-time types of objects but ignores their elements.

    Definition Classes
      IterableLike → Equals

22. #### def charAt(index: Int): Char

    Implicit information
      This member is added by an implicit conversion from Impl[A] to SeqCharSequence performed by method SeqCharSequence in scala.Predef. This conversion will take place only if A is a subclass of Char (A <: Char).
    Definition Classes
      SeqCharSequence → CharSequence

23. #### def chars(): IntStream

    Implicit information
      This member is added by an implicit conversion from Impl[A] to SeqCharSequence performed by method SeqCharSequence in scala.Predef. This conversion will take place only if A is a subclass of Char (A <: Char).
    Definition Classes
      CharSequence

24. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate() @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

25. #### def codePoints(): IntStream

    Implicit information
      This member is added by an implicit conversion from Impl[A] to SeqCharSequence performed by method SeqCharSequence in scala.Predef. This conversion will take place only if A is a subclass of Char (A <: Char).
    Definition Classes
      CharSequence

26. #### def collect[B](pf: PartialFunction[A, B]): IndexedSeq[B]

    [use case] Builds a new collection by applying a partial function to all elements of this immutable sequence on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this immutable sequence on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the immutable sequence.

    returns

      a new immutable sequence resulting from applying the given partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike
    Full Signature

    #### def collect[B, That](pf: PartialFunction[A, B])(implicit bf: CanBuildFrom[IndexedSeq[A], B, That]): That

27. #### def collectFirst[B](pf: PartialFunction[A, B]): Option[B]

    Finds the first element of the traversable or iterator for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the traversable or iterator for which the given partial function is defined, and applies the partial function to it.

    Note: may not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

28. #### def combinations(n: Int): Iterator[IndexedSeq[A]]

    Iterates over combinations.

    Iterates over combinations. A _combination_ of length `n` is a subsequence of the original sequence, with the elements taken in order. Thus, `"xy"` and `"yy"` are both length-2 combinations of `"xyy"`, but `"yx"` is not. If there is more than one way to generate the same subsequence, only one will be returned.

    For example, `"xyyy"` has three different ways to generate `"xy"` depending on whether the first, second, or third `"y"` is selected. However, since all are identical, only one will be chosen. Which of the three will be taken is an implementation detail that is not defined.

    returns

      An Iterator which traverses the possible n-element combinations of this sequence.

    Definition Classes
      SeqLike
    Example:

    1. `"abbbc".combinations(2) = Iterator(ab, ac, bb, bc)`

29. #### def companion: GenericCompanion[IndexedSeq]

    The factory companion object that builds instances of class IndexedSeq.

    The factory companion object that builds instances of class IndexedSeq. (or its `Iterable` superclass where class IndexedSeq is not a `Seq`.)

    Definition Classes
      IndexedSeq → IndexedSeq → Seq → Seq → GenSeq → Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → GenericTraversableTemplate

30. #### def compose[A](g: (A) ⇒ Int): (A) ⇒ A

    Composes two instances of Function1 in a new Function1, with this function applied last.

    Composes two instances of Function1 in a new Function1, with this function applied last.

    A

      the type to which function `g` can be applied

    g

      a function A => T1

    returns

      a new function `f` such that `f(x) == apply(g(x))`

    Definition Classes
      Function1
    Annotations
      @unspecialized()

31. #### def contains[A1 >: A](elem: A1): Boolean

    Tests whether this sequence contains a given value as an element.

    Tests whether this sequence contains a given value as an element.

    Note: may not terminate for infinite-sized collections.

    elem

      the element to test.

    returns

      `true` if this sequence has an element that is equal (as determined by `==`) to `elem`, `false` otherwise.

    Definition Classes
      SeqLike

32. #### def containsSlice[B](that: GenSeq[B]): Boolean

    Tests whether this sequence contains a given sequence as a slice.

    Tests whether this sequence contains a given sequence as a slice.

    Note: may not terminate for infinite-sized collections.

    that

      the sequence to test

    returns

      `true` if this sequence contains a slice with the same elements as `that`, otherwise `false`.

    Definition Classes
      SeqLike

33. #### def copyToArray(xs: Array[A], start: Int, len: Int): Unit

    [use case] Copies the elements of this immutable sequence to an array.

    [use case]

    Copies the elements of this immutable sequence to an array. Fills the given array `xs` with at most `len` elements of this immutable sequence, starting at position `start`. Copying will stop once either the end of the current immutable sequence is reached, or the end of the target array is reached, or `len` elements have been copied.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: A](xs: Array[B], start: Int, len: Int): Unit

34. #### def copyToArray(xs: Array[A]): Unit

    [use case] Copies the elements of this immutable sequence to an array.

    [use case]

    Copies the elements of this immutable sequence to an array. Fills the given array `xs` with values of this immutable sequence. Copying will stop once either the end of the current immutable sequence is reached, or the end of the target array is reached.

    xs

      the array to fill.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: A](xs: Array[B]): Unit

35. #### def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies the elements of this immutable sequence to an array.

    [use case]

    Copies the elements of this immutable sequence to an array. Fills the given array `xs` with values of this immutable sequence, beginning at index `start`. Copying will stop once either the end of the current immutable sequence is reached, or the end of the target array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: A](xs: Array[B], start: Int): Unit

36. #### def copyToBuffer[B >: A](dest: Buffer[B]): Unit

    Copies all elements of this traversable or iterator to a buffer.

    Copies all elements of this traversable or iterator to a buffer.

    Note: will not terminate for infinite-sized collections.

    dest

      The buffer to which elements are copied.

    Definition Classes
      TraversableOnce

37. #### def corresponds[B](that: GenSeq[B])(p: (A, B) ⇒ Boolean): Boolean

    Tests whether every element of this sequence relates to the corresponding element of another sequence by satisfying a test predicate.

    Tests whether every element of this sequence relates to the corresponding element of another sequence by satisfying a test predicate.

    B

      the type of the elements of `that`

    that

      the other sequence

    p

      the test predicate, which relates elements from both sequences

    returns

      `true` if both sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this sequence and `y` of `that`, otherwise `false`.

    Definition Classes
      SeqLike → GenSeqLike

38. #### def count(p: (A) ⇒ Boolean): Int

    Counts the number of elements in the traversable or iterator which satisfy a predicate.

    Counts the number of elements in the traversable or iterator which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

39. #### def diff(that: collection.Seq[A]): IndexedSeq[A]

    [use case] Computes the multiset difference between this immutable sequence and another sequence.

    [use case]

    Computes the multiset difference between this immutable sequence and another sequence.

    that

      the sequence of elements to remove

    returns

      a new immutable sequence which contains all elements of this immutable sequence except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      SeqLike → GenSeqLike
    Full Signature

    #### def diff[B >: A](that: GenSeq[B]): IndexedSeq[A]

40. #### def distinct: IndexedSeq[A]

    Builds a new sequence from this sequence without any duplicate elements.

    Builds a new sequence from this sequence without any duplicate elements.

    Note: will not terminate for infinite-sized collections.

    returns

      A new sequence which contains the first occurrence of every element of this sequence.

    Definition Classes
      SeqLike → GenSeqLike

41. #### def drop(n: Int): IndexedSeq[A]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      the number of elements to drop from this iterable collection.

    returns

      a iterable collection consisting of all elements of this iterable collection except the first `n` ones, or else the empty iterable collection, if this iterable collection has less than `n` elements.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike

42. #### def dropRight(n: Int): IndexedSeq[A]

    Selects all elements except last n ones.

    Selects all elements except last n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      The number of elements to take

    returns

      a iterable collection consisting of all elements of this iterable collection except the last `n` ones, or else the empty iterable collection, if this iterable collection has less than `n` elements.

    Definition Classes
      IterableLike

43. #### def dropWhile(p: (A) ⇒ Boolean): IndexedSeq[A]

    Drops longest prefix of elements that satisfy a predicate.

    Drops longest prefix of elements that satisfy a predicate.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the longest suffix of this traversable collection whose first element does not satisfy the predicate `p`.

    Definition Classes
      TraversableLike → GenTraversableLike

44. #### def endsWith[B](that: GenSeq[B]): Boolean

    Tests whether this sequence ends with the given sequence.

    Tests whether this sequence ends with the given sequence.

    Note: will not terminate for infinite-sized collections.

    that

      the sequence to test

    returns

      `true` if this sequence has `that` as a suffix, `false` otherwise.

    Definition Classes
      SeqLike → GenSeqLike

45. #### def ensuring(cond: (Impl[A]) ⇒ Boolean, msg: ⇒ Any): Impl[A]

    Implicit information
      This member is added by an implicit conversion from Impl[A] to Ensuring[Impl[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

46. #### def ensuring(cond: (Impl[A]) ⇒ Boolean): Impl[A]

    Implicit information
      This member is added by an implicit conversion from Impl[A] to Ensuring[Impl[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

47. #### def ensuring(cond: Boolean, msg: ⇒ Any): Impl[A]

    Implicit information
      This member is added by an implicit conversion from Impl[A] to Ensuring[Impl[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

48. #### def ensuring(cond: Boolean): Impl[A]

    Implicit information
      This member is added by an implicit conversion from Impl[A] to Ensuring[Impl[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

49. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

50. #### def equals(that: Any): Boolean

    The equals method for arbitrary sequences.

    The equals method for arbitrary sequences. Compares this sequence to some other object.

    that

      The object to compare the sequence to

    returns

      `true` if `that` is a sequence that has the same elements as this sequence in the same order, `false` otherwise

    Definition Classes
      GenSeqLike → Equals → Any

51. #### def exists(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for at least one element of this iterable collection.

    Tests whether a predicate holds for at least one element of this iterable collection.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      `false` if this iterable collection is empty, otherwise `true` if the given predicate `p` holds for some of the elements of this iterable collection, otherwise `false`

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

52. #### def filter(p: (A) ⇒ Boolean): IndexedSeq[A]

    Selects all elements of this traversable collection which satisfy a predicate.

    Selects all elements of this traversable collection which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new traversable collection consisting of all elements of this traversable collection that satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

53. #### def filterNot(p: (A) ⇒ Boolean): IndexedSeq[A]

    Selects all elements of this traversable collection which do not satisfy a predicate.

    Selects all elements of this traversable collection which do not satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new traversable collection consisting of all elements of this traversable collection that do not satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

54. #### def find(p: (A) ⇒ Boolean): Option[A]

    Finds the first element of the iterable collection satisfying a predicate, if any.

    Finds the first element of the iterable collection satisfying a predicate, if any.

    Note: may not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the iterable collection that satisfies `p`, or `None` if none exists.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

55. #### def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): IndexedSeq[B]

    [use case] Builds a new collection by applying a function to all elements of this immutable sequence and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this immutable sequence and using the elements of the resulting collections.

    For example:

        def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of immutable sequence. This might cause unexpected results sometimes. For example:

        // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
        def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

        // lettersOf will return a Set[Char], not a Seq
        def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

        // xs will be an Iterable[Int]
        val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

        // ys will be a Map[Int, Int]
        val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new immutable sequence resulting from applying the given collection-valued function `f` to each element of this immutable sequence and concatenating the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic
    Full Signature

    #### def flatMap[B, That](f: (A) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[IndexedSeq[A], B, That]): That

56. #### def flatten[B]: IndexedSeq[B]

    [use case] Converts this immutable sequence of traversable collections into a immutable sequence formed by the elements of these traversable collections.

    [use case]

    Converts this immutable sequence of traversable collections into a immutable sequence formed by the elements of these traversable collections.

    The resulting collection's type will be guided by the static type of immutable sequence. For example:

        val xs = List(
                   Set(1, 2, 3),
                   Set(1, 2, 3)
                 ).flatten
        // xs == List(1, 2, 3, 1, 2, 3)

        val ys = Set(
                   List(1, 2, 3),
                   List(3, 2, 1)
                 ).flatten
        // ys == Set(1, 2, 3)

    B

      the type of the elements of each traversable collection.

    returns

      a new immutable sequence resulting from concatenating all element immutable sequences.

    Definition Classes
      GenericTraversableTemplate
    Full Signature

    #### def flatten[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): IndexedSeq[B]

57. #### def fold[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this traversable or iterator using the specified associative binary operator.

    Folds the elements of this traversable or iterator using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    Note: will not terminate for infinite-sized collections.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication).

    op

      a binary operator that must be associative.

    returns

      the result of applying the fold operator `op` between all the elements and `z`, or `z` if this traversable or iterator is empty.

    Definition Classes
      TraversableOnce → GenTraversableOnce

58. #### def foldLeft[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this traversable or iterator, going left to right.

    Applies a binary operator to a start value and all elements of this traversable or iterator, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this traversable or iterator, going left to right with the start value `z` on the left:

          op(...op(z, x_1), x_2, ..., x_n)

      where `x1, ..., xn` are the elements of this traversable or iterator. Returns `z` if this traversable or iterator is empty.

    Definition Classes
      TraversableOnce → GenTraversableOnce

59. #### def foldRight[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this iterable collection and a start value, going right to left.

    Applies a binary operator to all elements of this iterable collection and a start value, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this iterable collection, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this iterable collection. Returns `z` if this iterable collection is empty.

    Definition Classes
      IterableLike → TraversableOnce → GenTraversableOnce

60. #### def forall(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this iterable collection.

    Tests whether a predicate holds for all elements of this iterable collection.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      `true` if this iterable collection is empty or the given predicate `p` holds for all elements of this iterable collection, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

61. #### def foreach(f: (A) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this immutable sequence.

    [use case]

    Applies a function `f` to all elements of this immutable sequence.

    Note: this method underlies the implementation of most other bulk operations. Subclasses should re-implement this method if a more efficient implementation exists.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike → TraversableOnce → GenTraversableOnce → FilterMonadic
    Full Signature

    #### def foreach[U](f: (A) ⇒ U): Unit

62. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from Impl[A] to StringFormat[Impl[A]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

63. #### def genericBuilder[B]: Builder[B, IndexedSeq[B]]

    The generic builder that builds instances of Traversable at arbitrary element types.

    The generic builder that builds instances of Traversable at arbitrary element types.

    Definition Classes
      GenericTraversableTemplate

64. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

65. #### def groupBy[K](f: (A) ⇒ K): Map[K, IndexedSeq[A]]

    Partitions this traversable collection into a map of traversable collections according to some discriminator function.

    Partitions this traversable collection into a map of traversable collections according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new traversable collection.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to traversable collections such that the following invariant holds:

          (xs groupBy f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a traversable collection of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      TraversableLike → GenTraversableLike

66. #### def grouped(size: Int): Iterator[IndexedSeq[A]]

    Partitions elements in fixed size iterable collections.

    Partitions elements in fixed size iterable collections.

    size

      the number of elements per group

    returns

      An iterator producing iterable collections of size `size`, except the last will be less than size `size` if the elements don't divide evenly.

    Definition Classes
      IterableLike
    See also

      scala.collection.Iterator, method `grouped`

67. #### def hasDefiniteSize: Boolean

    Tests whether this traversable collection is known to have a finite size.

    Tests whether this traversable collection is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end. Non-empty Iterators usually return `false` even if they were created from a collection with a known finite size.

    Note: many collection methods will not work on collections of infinite sizes. The typical failure mode is an infinite loop. These methods always attempt a traversal without checking first that `hasDefiniteSize` returns `true`. However, checking `hasDefiniteSize` can provide an assurance that size is well-defined and non-termination is not a concern.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

68. #### def hashCode(): Int

    Hashcodes for IndexedSeq produce a value from the hashcodes of all the elements of the sequence.

    Hashcodes for IndexedSeq produce a value from the hashcodes of all the elements of the sequence.

    returns

      the hash code value for this object.

    Definition Classes
      IndexedSeqLike → GenSeqLike → Any

69. #### def head: A

    Selects the first element of this iterable collection.

    Selects the first element of this iterable collection.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this iterable collection.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike
    Exceptions thrown

      `NoSuchElementException` if the iterable collection is empty.

70. #### def headOption: Option[A]

    Optionally selects the first element.

    Optionally selects the first element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this traversable collection if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike → GenTraversableLike

71. #### def indexOf(elem: A, from: Int): Int

    [use case] Finds index of first occurrence of some value in this immutable sequence after or at some start index.

    [use case]

    Finds index of first occurrence of some value in this immutable sequence after or at some start index.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this immutable sequence that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def indexOf[B >: A](elem: B, from: Int): Int

72. #### def indexOf(elem: A): Int

    [use case] Finds index of first occurrence of some value in this immutable sequence.

    [use case]

    Finds index of first occurrence of some value in this immutable sequence.

    elem

      the element value to search for.

    returns

      the index of the first element of this immutable sequence that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def indexOf[B >: A](elem: B): Int

73. #### def indexOfSlice[B >: A](that: GenSeq[B], from: Int): Int

    Finds first index after or at a start index where this sequence contains a given sequence as a slice.

    Finds first index after or at a start index where this sequence contains a given sequence as a slice.

    Note: may not terminate for infinite-sized collections.

    that

      the sequence to test

    from

      the start index

    returns

      the first index `>= from` such that the elements of this sequence starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

74. #### def indexOfSlice[B >: A](that: GenSeq[B]): Int

    Finds first index where this sequence contains a given sequence as a slice.

    Finds first index where this sequence contains a given sequence as a slice.

    Note: may not terminate for infinite-sized collections.

    that

      the sequence to test

    returns

      the first index such that the elements of this sequence starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

75. #### def indexWhere(p: (A) ⇒ Boolean, from: Int): Int

    Finds index of the first element satisfying some predicate after or at some start index.

    Finds index of the first element satisfying some predicate after or at some start index.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    from

      the start index

    returns

      the index `>= from` of the first element of this sequence that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      SeqLike → GenSeqLike

76. #### def indexWhere(p: (A) ⇒ Boolean): Int

    Finds index of first element satisfying some predicate.

    Finds index of first element satisfying some predicate.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      the index of the first element of this general sequence that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

77. #### def indices: Range

    Produces the range of all indices of this sequence.

    Produces the range of all indices of this sequence.

    returns

      a `Range` value from `0` to one less than the length of this sequence.

    Definition Classes
      SeqLike

78. #### def init: IndexedSeq[A]

    Selects all elements except the last.

    Selects all elements except the last.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      a traversable collection consisting of all elements of this traversable collection except the last one.

    Definition Classes
      TraversableLike → GenTraversableLike
    Exceptions thrown

      `UnsupportedOperationException` if the traversable collection is empty.

79. #### def inits: Iterator[IndexedSeq[A]]

    Iterates over the inits of this traversable collection.

    Iterates over the inits of this traversable collection. The first value will be this traversable collection and the final one will be an empty traversable collection, with the intervening values the results of successive applications of `init`.

    returns

      an iterator over all the inits of this traversable collection

    Definition Classes
      TraversableLike
    Example:

    1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

80. #### def intersect(that: collection.Seq[A]): IndexedSeq[A]

    [use case] Computes the multiset intersection between this immutable sequence and another sequence.

    [use case]

    Computes the multiset intersection between this immutable sequence and another sequence.

    that

      the sequence of elements to intersect with.

    returns

      a new immutable sequence which contains all elements of this immutable sequence which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

    Definition Classes
      SeqLike → GenSeqLike
    Full Signature

    #### def intersect[B >: A](that: GenSeq[B]): IndexedSeq[A]

81. #### def isDefinedAt(idx: Int): Boolean

    Tests whether this general sequence contains given index.

    Tests whether this general sequence contains given index.

    The implementations of methods `apply` and `isDefinedAt` turn a `Seq[A]` into a `PartialFunction[Int, A]`.

    idx

      the index to test

    returns

      `true` if this general sequence contains an element at position `idx`, `false` otherwise.

    Definition Classes
      GenSeqLike

82. #### def isEmpty: Boolean

    Tests whether this sequence is empty.

    Tests whether this sequence is empty.

    returns

      `true` if the sequence contain no elements, `false` otherwise.

    Definition Classes
      SeqLike → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

83. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

84. #### final def isTraversableAgain: Boolean

    Tests whether this traversable collection can be repeatedly traversed.

    Tests whether this traversable collection can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      TraversableLike → GenTraversableLike → GenTraversableOnce

85. #### def iterator: Iterator[A]

    Creates a new iterator over all elements contained in this iterable object.

    Creates a new iterator over all elements contained in this iterable object.

    returns

      the new iterator

    Definition Classes
      IndexedSeqLike → IterableLike → GenIterableLike

86. #### def last: A

    Selects the last element.

    Selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      The last element of this traversable collection.

    Definition Classes
      TraversableLike → GenTraversableLike
    Exceptions thrown

      `NoSuchElementException` If the traversable collection is empty.

87. #### def lastIndexOf(elem: A, end: Int): Int

    [use case] Finds index of last occurrence of some value in this immutable sequence before or at a given end index.

    [use case]

    Finds index of last occurrence of some value in this immutable sequence before or at a given end index.

    elem

      the element value to search for.

    end

      the end index.

    returns

      the index `<= end` of the last element of this immutable sequence that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def lastIndexOf[B >: A](elem: B, end: Int): Int

88. #### def lastIndexOf(elem: A): Int

    [use case] Finds index of last occurrence of some value in this immutable sequence.

    [use case]

    Finds index of last occurrence of some value in this immutable sequence.

    elem

      the element value to search for.

    returns

      the index of the last element of this immutable sequence that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def lastIndexOf[B >: A](elem: B): Int

89. #### def lastIndexOfSlice[B >: A](that: GenSeq[B], end: Int): Int

    Finds last index before or at a given end index where this sequence contains a given sequence as a slice.

    Finds last index before or at a given end index where this sequence contains a given sequence as a slice.

    that

      the sequence to test

    end

      the end index

    returns

      the last index `<= end` such that the elements of this sequence starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

90. #### def lastIndexOfSlice[B >: A](that: GenSeq[B]): Int

    Finds last index where this sequence contains a given sequence as a slice.

    Finds last index where this sequence contains a given sequence as a slice.

    Note: will not terminate for infinite-sized collections.

    that

      the sequence to test

    returns

      the last index such that the elements of this sequence starting a this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

91. #### def lastIndexWhere(p: (A) ⇒ Boolean, end: Int): Int

    Finds index of last element satisfying some predicate before or at given end index.

    Finds index of last element satisfying some predicate before or at given end index.

    p

      the predicate used to test elements.

    returns

      the index `<= end` of the last element of this sequence that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      SeqLike → GenSeqLike

92. #### def lastIndexWhere(p: (A) ⇒ Boolean): Int

    Finds index of last element satisfying some predicate.

    Finds index of last element satisfying some predicate.

    Note: will not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      the index of the last element of this general sequence that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

93. #### def lastOption: Option[A]

    Optionally selects the last element.

    Optionally selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the last element of this traversable collection$ if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike → GenTraversableLike

94. #### def length: Int

    The length of the immutable sequence.

    The length of the immutable sequence.

    Note: `xs.length` and `xs.size` yield the same result.

    returns

      the number of elements in this immutable sequence.

    Definition Classes
      Impl → SeqLike → GenSeqLike

95. #### def lengthCompare(len: Int): Int

    Compares the length of this sequence to a test value.

    Compares the length of this sequence to a test value.

    len

      the test value that gets compared with the length.

    returns

      A value `x` where

          x <  0       if this.length <  len
          x == 0       if this.length == len
          x >  0       if this.length >  len

      The method as implemented here does not call `length` directly; its running time is `O(length min len)` instead of `O(length)`. The method should be overwritten if computing `length` is cheap.

    Definition Classes
      SeqLike

96. #### def lift: (Int) ⇒ Option[A]

    Turns this partial function into a plain function returning an `Option` result.

    Turns this partial function into a plain function returning an `Option` result.

    returns

      a function that takes an argument `x` to `Some(this(x))` if `this` is defined for `x`, and to `None` otherwise.

    Definition Classes
      PartialFunction
    See also

      Function.unlift

97. #### def map[B](f: (A) ⇒ B): IndexedSeq[B]

    [use case] Builds a new collection by applying a function to all elements of this immutable sequence.

    [use case]

    Builds a new collection by applying a function to all elements of this immutable sequence.

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new immutable sequence resulting from applying the given function `f` to each element of this immutable sequence and collecting the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic
    Full Signature

    #### def map[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[IndexedSeq[A], B, That]): That

98. #### def max: A

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this immutable sequence.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def max[B >: A](implicit cmp: Ordering[B]): A

99. #### def maxBy[B](f: (A) ⇒ B): A

    [use case] Finds the first element which yields the largest value measured by function f.

    [use case]

    Finds the first element which yields the largest value measured by function f.

    B

      The result type of the function f.

    f

      The measuring function.

    returns

      the first element of this immutable sequence with the largest value measured by function f.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def maxBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

100. #### def min: A

     [use case] Finds the smallest element.

     [use case]

     Finds the smallest element.

     returns

       the smallest element of this immutable sequence

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def min[B >: A](implicit cmp: Ordering[B]): A

101. #### def minBy[B](f: (A) ⇒ B): A

     [use case] Finds the first element which yields the smallest value measured by function f.

     [use case]

     Finds the first element which yields the smallest value measured by function f.

     B

       The result type of the function f.

     f

       The measuring function.

     returns

       the first element of this immutable sequence with the smallest value measured by function f.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def minBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

102. #### def mkString: String

     Displays all elements of this traversable or iterator in a string.

     Displays all elements of this traversable or iterator in a string.

     returns

       a string representation of this traversable or iterator. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator follow each other without any separator string.

     Definition Classes
       TraversableOnce → GenTraversableOnce

103. #### def mkString(sep: String): String

     Displays all elements of this traversable or iterator in a string using a separator string.

     Displays all elements of this traversable or iterator in a string using a separator string.

     sep

       the separator string.

     returns

       a string representation of this traversable or iterator. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("|") = "1|2|3"`

104. #### def mkString(start: String, sep: String, end: String): String

     Displays all elements of this traversable or iterator in a string using start, end, and separator strings.

     Displays all elements of this traversable or iterator in a string using start, end, and separator strings.

     start

       the starting string.

     sep

       the separator string.

     end

       the ending string.

     returns

       a string representation of this traversable or iterator. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

105. #### final def ne(arg0: AnyRef): Boolean

     Equivalent to `!(this eq that)`.

     Equivalent to `!(this eq that)`.

     returns

       `true` if the argument is not a reference to the receiver object; `false` otherwise.

     Definition Classes
       AnyRef

106. #### def newBuilder: Builder[A, IndexedSeq[A]]

     The builder that builds instances of type Traversable[A]

     The builder that builds instances of type Traversable[A]

     Attributes
       protected[this]
     Definition Classes
       GenericTraversableTemplate → HasNewBuilder

107. #### def nonEmpty: Boolean

     Tests whether the traversable or iterator is not empty.

     Tests whether the traversable or iterator is not empty.

     returns

       `true` if the traversable or iterator contains at least one element, `false` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

108. #### final def notify(): Unit

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Annotations
       @IntrinsicCandidate()
     Note

       not specified by SLS as a member of AnyRef

109. #### final def notifyAll(): Unit

     Wakes up all threads that are waiting on the receiver object's monitor.

     Wakes up all threads that are waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Annotations
       @IntrinsicCandidate()
     Note

       not specified by SLS as a member of AnyRef

110. #### def orElse[A1 <: Int, B1 >: A](that: PartialFunction[A1, B1]): PartialFunction[A1, B1]

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     A1

       the argument type of the fallback function

     B1

       the result type of the fallback function

     that

       the fallback function

     returns

       a partial function which has as domain the union of the domains of this partial function and `that`. The resulting partial function takes `x` to `this(x)` where `this` is defined, and to `that(x)` where it is not.

     Definition Classes
       PartialFunction

111. #### def padTo(len: Int, elem: A): IndexedSeq[A]

     [use case] A copy of this immutable sequence with an element value appended until a given target length is reached.

     [use case]

     A copy of this immutable sequence with an element value appended until a given target length is reached.

     len

       the target length

     elem

       the padding value

     returns

       a new immutable sequence consisting of all elements of this immutable sequence followed by the minimal number of occurrences of `elem` so that the resulting immutable sequence has a length of at least `len`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def padTo[B >: A, That](len: Int, elem: B)(implicit bf: CanBuildFrom[IndexedSeq[A], B, That]): That

112. #### def par: ParSeq[A]

     Returns a parallel implementation of this collection.

     Returns a parallel implementation of this collection.

     For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

     Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

     All parallel collections return a reference to themselves.

     returns

       a parallel implementation of this collection

     Definition Classes
       Parallelizable

113. #### def parCombiner: Combiner[A, ParSeq[A]]

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     returns

       a combiner for the parallel collection of type `ParRepr`

     Attributes
       protected[this]
     Definition Classes
       Seq → SeqLike → Iterable → TraversableLike → Parallelizable

114. #### def partition(p: (A) ⇒ Boolean): (IndexedSeq[A], IndexedSeq[A])

     Partitions this traversable collection in two traversable collections according to a predicate.

     Partitions this traversable collection in two traversable collections according to a predicate.

     p

       the predicate on which to partition.

     returns

       a pair of traversable collections: the first traversable collection consists of all elements that satisfy the predicate `p` and the second traversable collection consists of all elements that don't. The relative order of the elements in the resulting traversable collections is the same as in the original traversable collection.

     Definition Classes
       TraversableLike → GenTraversableLike

115. #### def patch(from: Int, that: GenSeq[A], replaced: Int): IndexedSeq[A]

     [use case] Produces a new immutable sequence where a slice of elements in this immutable sequence is replaced by another sequence.

     [use case]

     Produces a new immutable sequence where a slice of elements in this immutable sequence is replaced by another sequence.

     from

       the index of the first replaced element

     replaced

       the number of elements to drop in the original immutable sequence

     returns

       a new immutable sequence consisting of all elements of this immutable sequence except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def patch[B >: A, That](from: Int, patch: GenSeq[B], replaced: Int)(implicit bf: CanBuildFrom[IndexedSeq[A], B, That]): That

116. #### def permutations: Iterator[IndexedSeq[A]]

     Iterates over distinct permutations.

     Iterates over distinct permutations.

     returns

       An Iterator which traverses the distinct permutations of this sequence.

     Definition Classes
       SeqLike
     Example:

     1. `"abb".permutations = Iterator(abb, bab, bba)`

117. #### def prefixLength(p: (A) ⇒ Boolean): Int

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     Note: may not terminate for infinite-sized collections.

     p

       the predicate used to test elements.

     returns

       the length of the longest prefix of this general sequence such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       GenSeqLike

118. #### def product: A

     [use case] Multiplies up the elements of this collection.

     [use case]

     Multiplies up the elements of this collection.

     returns

       the product of all elements in this immutable sequence of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the immutable sequence and as result type of `product`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def product[B >: A](implicit num: Numeric[B]): B

119. #### def reduce[A1 >: A](op: (A1, A1) ⇒ A1): A1

     Reduces the elements of this traversable or iterator using the specified associative binary operator.

     Reduces the elements of this traversable or iterator using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       The result of applying reduce operator `op` between all the elements if the traversable or iterator is nonempty.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Exceptions thrown

       `UnsupportedOperationException` if this traversable or iterator is empty.

120. #### def reduceLeft[B >: A](op: (B, A) ⇒ B): B

     Applies a binary operator to all elements of this traversable or iterator, going left to right.

     Applies a binary operator to all elements of this traversable or iterator, going left to right.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this traversable or iterator, going left to right:

           op( op( ... op(x_1, x_2) ..., x_{n-1}), x_n)

       where `x1, ..., xn` are the elements of this traversable or iterator.

     Definition Classes
       TraversableOnce
     Exceptions thrown

       `UnsupportedOperationException` if this traversable or iterator is empty.

121. #### def reduceLeftOption[B >: A](op: (B, A) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this traversable or iterator, going left to right.

     Optionally applies a binary operator to all elements of this traversable or iterator, going left to right.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceLeft(op)` if this traversable or iterator is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

122. #### def reduceOption[A1 >: A](op: (A1, A1) ⇒ A1): Option[A1]

     Reduces the elements of this traversable or iterator, if any, using the specified associative binary operator.

     Reduces the elements of this traversable or iterator, if any, using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

123. #### def reduceRight[B >: A](op: (A, B) ⇒ B): B

     Applies a binary operator to all elements of this iterable collection, going right to left.

     Applies a binary operator to all elements of this iterable collection, going right to left.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this iterable collection, going right to left:

           op(x_1, op(x_2, ..., op(x_{n-1}, x_n)...))

       where `x1, ..., xn` are the elements of this iterable collection.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce
     Exceptions thrown

       `UnsupportedOperationException` if this iterable collection is empty.

124. #### def reduceRightOption[B >: A](op: (A, B) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this traversable or iterator, going right to left.

     Optionally applies a binary operator to all elements of this traversable or iterator, going right to left.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` if this traversable or iterator is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

125. #### def repr: IndexedSeq[A]

     The collection of type traversable collection underlying this `TraversableLike` object.

     The collection of type traversable collection underlying this `TraversableLike` object. By default this is implemented as the `TraversableLike` object itself, but this can be overridden.

     Definition Classes
       TraversableLike → GenTraversableLike

126. #### def reverse: IndexedSeq[A]

     Returns new sequence with elements in reversed order.

     Returns new sequence with elements in reversed order.

     Note: will not terminate for infinite-sized collections.

     returns

       A new sequence with all elements of this sequence in reversed order.

     Definition Classes
       SeqLike → GenSeqLike

127. #### def reverseIterator: Iterator[A]

     An iterator yielding elements in reversed order.

     An iterator yielding elements in reversed order.

     Note: will not terminate for infinite-sized collections.

     Note: `xs.reverseIterator` is the same as `xs.reverse.iterator` but might be more efficient.

     returns

       an iterator yielding the elements of this sequence in reversed order

     Definition Classes
       SeqLike

128. #### def reverseMap[B](f: (A) ⇒ B): IndexedSeq[B]

     [use case] Builds a new collection by applying a function to all elements of this immutable sequence and collecting the results in reversed order.

     [use case]

     Builds a new collection by applying a function to all elements of this immutable sequence and collecting the results in reversed order.

     Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new immutable sequence resulting from applying the given function `f` to each element of this immutable sequence and collecting the results in reversed order.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def reverseMap[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[IndexedSeq[A], B, That]): That

129. #### def reversed: scala.List[A]

     Attributes
       protected[this]
     Definition Classes
       TraversableOnce

130. #### def runWith[U](action: (A) ⇒ U): (Int) ⇒ Boolean

     Composes this partial function with an action function which gets applied to results of this partial function.

     Composes this partial function with an action function which gets applied to results of this partial function. The action function is invoked only for its side effects; its result is ignored.

     Note that expression `pf.runWith(action)(x)` is equivalent to

         if(pf isDefinedAt x) { action(pf(x)); true } else false

     except that `runWith` is implemented via `applyOrElse` and thus potentially more efficient. Using `runWith` avoids double evaluation of pattern matchers and guards for partial function literals.

     action

       the action function

     returns

       a function which maps arguments `x` to `isDefinedAt(x)`. The resulting function runs `action(this(x))` where `this` is defined.

     Definition Classes
       PartialFunction
     Since

       2.10

     See also

       `applyOrElse`.

131. #### def sameElements(that: GenIterable[A]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this immutable sequence.

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this immutable sequence.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def sameElements[B >: A](that: GenIterable[B]): Boolean

132. #### def scan[B >: A, That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[IndexedSeq[A], B, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     B

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     cbf

       combiner factory which provides a combiner

     returns

       a new traversable collection containing the prefix scan of the elements in this traversable collection

     Definition Classes
       TraversableLike → GenTraversableLike

133. #### def scanLeft[B, That](z: B)(op: (B, A) ⇒ B)(implicit bf: CanBuildFrom[IndexedSeq[A], B, That]): That

     Produces a collection containing cumulative results of applying the operator going left to right.

     Produces a collection containing cumulative results of applying the operator going left to right.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike

134. #### def scanRight[B, That](z: B)(op: (A, B) ⇒ B)(implicit bf: CanBuildFrom[IndexedSeq[A], B, That]): That

     Produces a collection containing cumulative results of applying the operator going right to left.

     Produces a collection containing cumulative results of applying the operator going right to left. The head of the collection is the last cumulative result.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     Example:

         List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

135. #### def segmentLength(p: (A) ⇒ Boolean, from: Int): Int

     Computes length of longest segment whose elements all satisfy some predicate.

     Computes length of longest segment whose elements all satisfy some predicate.

     Note: may not terminate for infinite-sized collections.

     p

       the predicate used to test elements.

     from

       the index where the search starts.

     returns

       the length of the longest segment of this sequence starting from index `from` such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       SeqLike → GenSeqLike

136. #### def seq: IndexedSeq[A]

     A version of this collection with all of the operations implemented sequentially (i.e., in a single-threaded manner).

     A version of this collection with all of the operations implemented sequentially (i.e., in a single-threaded manner).

     This method returns a reference to this collection. In parallel collections, it is redefined to return a sequential implementation of this collection. In both cases, it has O(1) complexity.

     returns

       a sequential view of the collection.

     Definition Classes
       IndexedSeq → IndexedSeq → IndexedSeqLike → Seq → Seq → GenSeq → GenSeqLike → Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → Parallelizable → TraversableOnce → GenTraversableOnce

137. #### def size: Int

     The size of this sequence, equivalent to `length`.

     The size of this sequence, equivalent to `length`.

     Note: will not terminate for infinite-sized collections.

     returns

       the number of elements in this sequence.

     Definition Classes
       SeqLike → GenTraversableLike → TraversableOnce → GenTraversableOnce

138. #### def slice(from: Int, until: Int): IndexedSeq[A]

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

         from <= indexOf(x) < until

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       a iterable collection containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this iterable collection.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

139. #### def sliding(size: Int, step: Int): Iterator[IndexedSeq[A]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     step

       the distance between the first elements of successive groups

     returns

       An iterator producing iterable collections of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       scala.collection.Iterator, method `sliding`

140. #### def sliding(size: Int): Iterator[IndexedSeq[A]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.) "Sliding window" step is 1 by default.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.) "Sliding window" step is 1 by default.

     size

       the number of elements per group

     returns

       An iterator producing iterable collections of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       scala.collection.Iterator, method `sliding`

141. #### def sortBy[B](f: (A) ⇒ B)(implicit ord: math.Ordering[B]): IndexedSeq[A]

     Sorts this `Seq` according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     Sorts this `Seq` according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     B

       the target type of the transformation `f`, and the type where the ordering `ord` is defined.

     f

       the transformation function mapping elements to some other domain `B`.

     ord

       the ordering assumed on domain `B`.

     returns

       a sequence consisting of the elements of this sequence sorted according to the ordering where `x < y` if `ord.lt(f(x), f(y))`.

     Definition Classes
       SeqLike
     Example:

     1.     val words = "The quick brown fox jumped over the lazy dog".split(' ')
            // this works because scala.Ordering will implicitly provide an Ordering[Tuple2[Int, Char]]
            words.sortBy(x => (x.length, x.head))
            res0: Array[String] = Array(The, dog, fox, the, lazy, over, brown, quick, jumped)

     See also

       scala.math.Ordering Note: will not terminate for infinite-sized collections.

142. #### def sortWith(lt: (A, A) ⇒ Boolean): IndexedSeq[A]

     Sorts this sequence according to a comparison function.

     Sorts this sequence according to a comparison function.

     Note: will not terminate for infinite-sized collections.

     The sort is stable. That is, elements that are equal (as determined by `lt`) appear in the same order in the sorted sequence as in the original.

     lt

       the comparison function which tests whether its first argument precedes its second argument in the desired ordering.

     returns

       a sequence consisting of the elements of this sequence sorted according to the comparison function `lt`.

     Definition Classes
       SeqLike
     Example:

     1.     List("Steve", "Tom", "John", "Bob").sortWith(_.compareTo(_) < 0) =
            List("Bob", "John", "Steve", "Tom")

143. #### def sorted[B >: A](implicit ord: math.Ordering[B]): IndexedSeq[A]

     Sorts this sequence according to an Ordering.

     Sorts this sequence according to an Ordering.

     The sort is stable. That is, elements that are equal (as determined by `lt`) appear in the same order in the sorted sequence as in the original.

     ord

       the ordering to be used to compare elements.

     returns

       a sequence consisting of the elements of this sequence sorted according to the ordering `ord`.

     Definition Classes
       SeqLike
     See also

       scala.math.Ordering

144. #### def span(p: (A) ⇒ Boolean): (IndexedSeq[A], IndexedSeq[A])

     Splits this traversable collection into a prefix/suffix pair according to a predicate.

     Splits this traversable collection into a prefix/suffix pair according to a predicate.

     Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       a pair consisting of the longest prefix of this traversable collection whose elements all satisfy `p`, and the rest of this traversable collection.

     Definition Classes
       TraversableLike → GenTraversableLike

145. #### def splitAt(n: Int): (IndexedSeq[A], IndexedSeq[A])

     Splits this traversable collection into two at a given position.

     Splits this traversable collection into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the position at which to split.

     returns

       a pair of traversable collections consisting of the first `n` elements of this traversable collection, and the other elements.

     Definition Classes
       TraversableLike → GenTraversableLike

146. #### def startsWith[B](that: GenSeq[B], offset: Int): Boolean

     Tests whether this sequence contains the given sequence at a given index.

     Tests whether this sequence contains the given sequence at a given index.

     Note: If the both the receiver object `this` and the argument `that` are infinite sequences this method may not terminate.

     that

       the sequence to test

     offset

       the index where the sequence is searched.

     returns

       `true` if the sequence `that` is contained in this sequence at index `offset`, otherwise `false`.

     Definition Classes
       SeqLike → GenSeqLike

147. #### def startsWith[B](that: GenSeq[B]): Boolean

     Tests whether this general sequence starts with the given sequence.

     Tests whether this general sequence starts with the given sequence.

     that

       the sequence to test

     returns

       `true` if this collection has `that` as a prefix, `false` otherwise.

     Definition Classes
       GenSeqLike

148. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this traversable collection. By default the string prefix is the simple name of the collection class traversable collection.

     Definition Classes
       TraversableLike → GenTraversableLike

149. #### def subSequence(start: Int, end: Int): CharSequence

     Implicit information
       This member is added by an implicit conversion from Impl[A] to SeqCharSequence performed by method SeqCharSequence in scala.Predef. This conversion will take place only if A is a subclass of Char (A <: Char).
     Definition Classes
       SeqCharSequence → CharSequence

150. #### def sum: A

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements in this immutable sequence of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the immutable sequence and as result type of `sum`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def sum[B >: A](implicit num: Numeric[B]): B

151. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

152. #### def tail: IndexedSeq[A]

     Selects all elements except the first.

     Selects all elements except the first.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       a traversable collection consisting of all elements of this traversable collection except the first one.

     Definition Classes
       TraversableLike → GenTraversableLike
     Exceptions thrown

       ``UnsupportedOperationException`` if the traversable collection is empty.

153. #### def tails: Iterator[IndexedSeq[A]]

     Iterates over the tails of this traversable collection.

     Iterates over the tails of this traversable collection. The first value will be this traversable collection and the final one will be an empty traversable collection, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this traversable collection

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

154. #### def take(n: Int): IndexedSeq[A]

     Selects first n elements.

     Selects first n elements.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the number of elements to take from this iterable collection.

     returns

       a iterable collection consisting only of the first `n` elements of this iterable collection, or else the whole iterable collection, if it has less than `n` elements.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

155. #### def takeRight(n: Int): IndexedSeq[A]

     Selects last n elements.

     Selects last n elements.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the number of elements to take

     returns

       a iterable collection consisting only of the last `n` elements of this iterable collection, or else the whole iterable collection, if it has less than `n` elements.

     Definition Classes
       IterableLike

156. #### def takeWhile(p: (A) ⇒ Boolean): IndexedSeq[A]

     Takes longest prefix of elements that satisfy a predicate.

     Takes longest prefix of elements that satisfy a predicate.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       the longest prefix of this iterable collection whose elements all satisfy the predicate `p`.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

157. #### def thisCollection: collection.IndexedSeq[A]

     The underlying collection seen as an instance of `IndexedSeq`.

     The underlying collection seen as an instance of `IndexedSeq`. By default this is implemented as the current collection object itself, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       IndexedSeqLike → SeqLike → IterableLike → TraversableLike

158. #### def to[Col[_]]: Col[A]

     [use case] Converts this immutable sequence into another by copying all elements.

     [use case]

     Converts this immutable sequence into another by copying all elements.

     Col

       The collection type to build.

     returns

       a new collection containing all elements of this immutable sequence.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce
     Full Signature

     #### def to[Col[_]](implicit cbf: CanBuildFrom[Nothing, A, Col[A]]): Col[A]

159. #### def toArray: Array[A]

     [use case] Converts this immutable sequence to an array.

     [use case]

     Converts this immutable sequence to an array.

     returns

       an array containing all elements of this immutable sequence. An `ClassTag` must be available for the element type of this immutable sequence.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def toArray[B >: A](implicit arg0: ClassTag[B]): Array[B]

160. #### def toBuffer[A1 >: A]: Buffer[A1]

     Uses the contents of this sequence to create a new mutable buffer.

     Uses the contents of this sequence to create a new mutable buffer.

     returns

       a buffer containing all elements of this sequence.

     Definition Classes
       IndexedSeqLike → TraversableOnce → GenTraversableOnce

161. #### def toCollection(repr: IndexedSeq[A]): collection.IndexedSeq[A]

     A conversion from collections of type `Repr` to `IndexedSeq` objects.

     A conversion from collections of type `Repr` to `IndexedSeq` objects. By default this is implemented as just a cast, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       IndexedSeqLike → SeqLike → IterableLike → TraversableLike

162. #### def toIndexedSeq: IndexedSeq[A]

     Returns this immutable sequence as an indexed sequence.

     Returns this immutable sequence as an indexed sequence.

     A new indexed sequence will not be built; lazy collections will stay lazy.

     returns

       an indexed sequence containing all elements of this immutable sequence.

     Definition Classes
       IndexedSeq → TraversableOnce → GenTraversableOnce
     Annotations
       @deprecatedOverriding( ... , "2.11.0" )

163. #### def toIterable: collection.Iterable[A]

     Returns this iterable collection as an iterable collection.

     Returns this iterable collection as an iterable collection.

     A new collection will not be built; lazy collections will stay lazy.

     Note: will not terminate for infinite-sized collections.

     returns

       an `Iterable` containing all elements of this iterable collection.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce

164. #### def toIterator: Iterator[A]

     Returns an Iterator over the elements in this iterable collection.

     Returns an Iterator over the elements in this iterable collection. Produces the same result as `iterator`.

     Note: will not terminate for infinite-sized collections.

     returns

       an Iterator containing all elements of this iterable collection.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce
     Annotations
       @deprecatedOverriding( ... , "2.11.0" )

165. #### def toList: scala.List[A]

     Converts this traversable or iterator to a list.

     Converts this traversable or iterator to a list.

     Note: will not terminate for infinite-sized collections.

     returns

       a list containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

166. #### def toMap[T, U]: collection.Map[T, U]

     [use case] Converts this immutable sequence to a map.

     [use case]

     Converts this immutable sequence to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map of type `immutable.Map[T, U]` containing all key/value pairs of type `(T, U)` of this immutable sequence.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def toMap[T, U](implicit ev: <:<[A, (T, U)]): Map[T, U]

167. #### def toParArray: ParArray[T]

     Implicit information
       This member is added by an implicit conversion from Impl[A] to CollectionsHaveToParArray[Impl[A], T] performed by method CollectionsHaveToParArray in scala.collection.parallel. This conversion will take place only if an implicit value of type (Impl[A]) ⇒ GenTraversableOnce[T] is in scope.
     Definition Classes
       CollectionsHaveToParArray

168. #### def toSeq: Seq[A]

     Converts this immutable sequence to a sequence.

     Converts this immutable sequence to a sequence.

     Note: will not terminate for infinite-sized collections.

     A new collection will not be built; in particular, lazy sequences will stay lazy.

     returns

       a sequence containing all elements of this immutable sequence.

     Definition Classes
       Seq → SeqLike → GenSeqLike → TraversableOnce → GenTraversableOnce

169. #### def toSet[B >: A]: Set[B]

     Converts this traversable or iterator to a set.

     Converts this traversable or iterator to a set.

     Note: will not terminate for infinite-sized collections.

     returns

       a set containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

170. #### def toStream: Stream[A]

     Converts this iterable collection to a stream.

     Converts this iterable collection to a stream.

     returns

       a stream containing all elements of this iterable collection.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce

171. #### def toString(): String

     Converts this sequence to a string.

     Converts this sequence to a string.

     returns

       a string representation of this collection. By default this string consists of the `stringPrefix` of this sequence, followed by all elements separated by commas and enclosed in parentheses.

     Definition Classes
       SeqLike → TraversableLike → Any

172. #### def toTraversable: collection.Traversable[A]

     Converts this traversable collection to an unspecified Traversable.

     Converts this traversable collection to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     Note: will not terminate for infinite-sized collections.

     returns

       a Traversable containing all elements of this traversable collection.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce
     Annotations
       @deprecatedOverriding( ... , "2.11.0" )

173. #### def toVector: scala.Vector[A]

     Converts this traversable or iterator to a Vector.

     Converts this traversable or iterator to a Vector.

     Note: will not terminate for infinite-sized collections.

     returns

       a vector containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

174. #### def transpose[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): IndexedSeq[IndexedSeq[B]]

     Transposes this collection of traversable collections into a collection of collections.

     Transposes this collection of traversable collections into a collection of collections.

     The resulting collection's type will be guided by the static type of collection. For example:

         val xs = List(
                    Set(1, 2, 3),
                    Set(4, 5, 6)).transpose
         // xs == List(
         //         List(1, 4),
         //         List(2, 5),
         //         List(3, 6))

         val ys = Vector(
                    List(1, 2, 3),
                    List(4, 5, 6)).transpose
         // ys == Vector(
         //         Vector(1, 4),
         //         Vector(2, 5),
         //         Vector(3, 6))

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this collection is a `Traversable`.

     returns

       a two-dimensional collection of collections which has as nth row the nth column of this collection.

     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown

       `IllegalArgumentException` if all collections in this collection are not of the same size.

175. #### def union(that: collection.Seq[A]): IndexedSeq[A]

     [use case] Produces a new sequence which contains all elements of this immutable sequence and also all elements of a given sequence.

     [use case]

     Produces a new sequence which contains all elements of this immutable sequence and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     Another way to express this is that `xs union ys` computes the order-preserving multi-set union of `xs` and `ys`. `union` is hence a counter-part of `diff` and `intersect` which also work on multi-sets.

     that

       the sequence to add.

     returns

       a new immutable sequence which contains all elements of this immutable sequence followed by all elements of `that`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def union[B >: A, That](that: GenSeq[B])(implicit bf: CanBuildFrom[IndexedSeq[A], B, That]): That

176. #### def unzip[A1, A2](implicit asPair: (A) ⇒ (A1, A2)): (IndexedSeq[A1], IndexedSeq[A2])

     Converts this collection of pairs into two collections of the first and second half of each pair.

     Converts this collection of pairs into two collections of the first and second half of each pair.

         val xs = Traversable(
                    (1, "one"),
                    (2, "two"),
                    (3, "three")).unzip
         // xs == (Traversable(1, 2, 3),
         //        Traversable(one, two, three))

     A1

       the type of the first half of the element pairs

     A2

       the type of the second half of the element pairs

     asPair

       an implicit conversion which asserts that the element type of this collection is a pair.

     returns

       a pair of collections, containing the first, respectively second half of each element pair of this collection.

     Definition Classes
       GenericTraversableTemplate

177. #### def unzip3[A1, A2, A3](implicit asTriple: (A) ⇒ (A1, A2, A3)): (IndexedSeq[A1], IndexedSeq[A2], IndexedSeq[A3])

     Converts this collection of triples into three collections of the first, second, and third element of each triple.

     Converts this collection of triples into three collections of the first, second, and third element of each triple.

         val xs = Traversable(
                    (1, "one", '1'),
                    (2, "two", '2'),
                    (3, "three", '3')).unzip3
         // xs == (Traversable(1, 2, 3),
         //        Traversable(one, two, three),
         //        Traversable(1, 2, 3))

     A1

       the type of the first member of the element triples

     A2

       the type of the second member of the element triples

     A3

       the type of the third member of the element triples

     asTriple

       an implicit conversion which asserts that the element type of this collection is a triple.

     returns

       a triple of collections, containing the first, second, respectively third member of each element triple of this collection.

     Definition Classes
       GenericTraversableTemplate

178. #### def updated(index: Int, elem: A): IndexedSeq[A]

     [use case] A copy of this immutable sequence with one single replaced element.

     [use case]

     A copy of this immutable sequence with one single replaced element.

     index

       the position of the replacement

     elem

       the replacing element

     returns

       a copy of this immutable sequence with the element at position `index` replaced by `elem`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def updated[B >: A, That](index: Int, elem: B)(implicit bf: CanBuildFrom[IndexedSeq[A], B, That]): That

179. #### def view(from: Int, until: Int): SeqView[A, IndexedSeq[A]]

     Creates a non-strict view of a slice of this sequence.

     Creates a non-strict view of a slice of this sequence.

     Note: the difference between `view` and `slice` is that `view` produces a view of the current sequence, whereas `slice` produces a new sequence.

     Note: `view(from, to)` is equivalent to `view.slice(from, to)`

     from

       the index of the first element of the view

     until

       the index of the element following the view

     returns

       a non-strict view of a slice of this sequence, starting at index `from` and extending up to (but not including) index `until`.

     Definition Classes
       SeqLike → IterableLike → TraversableLike

180. #### def view: SeqView[A, IndexedSeq[A]]

     Creates a non-strict view of this sequence.

     Creates a non-strict view of this sequence.

     returns

       a non-strict view of this sequence.

     Definition Classes
       SeqLike → IterableLike → TraversableLike

181. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

182. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

183. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

184. #### def withFilter(p: (A) ⇒ Boolean): FilterMonadic[A, IndexedSeq[A]]

     Creates a non-strict filter of this traversable collection.

     Creates a non-strict filter of this traversable collection.

     Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     p

       the predicate used to test elements.

     returns

       an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this traversable collection which satisfy the predicate `p`.

     Definition Classes
       TraversableLike → FilterMonadic

185. #### def zip[B](that: GenIterable[B]): IndexedSeq[(A, B)]

     [use case] Returns a immutable sequence formed from this immutable sequence and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a immutable sequence formed from this immutable sequence and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new immutable sequence containing pairs consisting of corresponding elements of this immutable sequence and `that`. The length of the returned collection is the minimum of the lengths of this immutable sequence and `that`.

     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def zip[A1 >: A, B, That](that: GenIterable[B])(implicit bf: CanBuildFrom[IndexedSeq[A], (A1, B), That]): That

186. #### def zipAll[B](that: collection.Iterable[B], thisElem: A, thatElem: B): IndexedSeq[(A, B)]

     [use case] Returns a immutable sequence formed from this immutable sequence and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a immutable sequence formed from this immutable sequence and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this immutable sequence is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this immutable sequence.

     returns

       a new immutable sequence containing pairs consisting of corresponding elements of this immutable sequence and `that`. The length of the returned collection is the maximum of the lengths of this immutable sequence and `that`. If this immutable sequence is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this immutable sequence, `thatElem` values are used to pad the result.

     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def zipAll[B, A1 >: A, That](that: GenIterable[B], thisElem: A1, thatElem: B)(implicit bf: CanBuildFrom[IndexedSeq[A], (A1, B), That]): That

187. #### def zipWithIndex: IndexedSeq[(A, Int)]

     [use case] Zips this immutable sequence with its indices.

     [use case]

     Zips this immutable sequence with its indices.

     returns

       A new immutable sequence containing pairs consisting of all elements of this immutable sequence paired with their index. Indices start at `0`.

     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def zipWithIndex[A1 >: A, That](implicit bf: CanBuildFrom[IndexedSeq[A], (A1, Int), That]): That

     Example:

     1. `List("a", "b", "c").zipWithIndex = List(("a", 0), ("b", 1), ("c", 2))`

188. #### def →[B](y: B): (Impl[A], B)

     Implicit information
       This member is added by an implicit conversion from Impl[A] to ArrowAssoc[Impl[A]] performed by method ArrowAssoc in scala.Predef.
     Definition Classes
       ArrowAssoc

### Shadowed Implicit Value Members

1. #### def filter(p: (A) ⇒ Boolean): TraversableOnce[A]

   Implicit information
     This member is added by an implicit conversion from Impl[A] to MonadOps[A] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (impl: MonadOps[A]).filter(p)

   Definition Classes
     MonadOps

2. #### def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): TraversableOnce[B]

   Implicit information
     This member is added by an implicit conversion from Impl[A] to MonadOps[A] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (impl: MonadOps[A]).flatMap(f)

   Definition Classes
     MonadOps

3. #### def isEmpty(): Boolean

   Implicit information
     This member is added by an implicit conversion from Impl[A] to SeqCharSequence performed by method SeqCharSequence in scala.Predef. This conversion will take place only if A is a subclass of Char (A <: Char).
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (impl: SeqCharSequence).isEmpty()

   Definition Classes
     CharSequence

4. #### def length(): Int

   Implicit information
     This member is added by an implicit conversion from Impl[A] to SeqCharSequence performed by method SeqCharSequence in scala.Predef. This conversion will take place only if A is a subclass of Char (A <: Char).
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (impl: SeqCharSequence).length()

   Definition Classes
     SeqCharSequence → CharSequence

5. #### def map[B](f: (A) ⇒ B): TraversableOnce[B]

   Implicit information
     This member is added by an implicit conversion from Impl[A] to MonadOps[A] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (impl: MonadOps[A]).map(f)

   Definition Classes
     MonadOps

6. #### def toString(): String

   Creates a String representation of this object.

   Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

   returns

     a String representation of the object.

   Implicit information
     This member is added by an implicit conversion from Impl[A] to SeqCharSequence performed by method SeqCharSequence in scala.Predef. This conversion will take place only if A is a subclass of Char (A <: Char).
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (impl: SeqCharSequence).toString()

   Definition Classes
     SeqCharSequence → CharSequence → AnyRef → Any

7. #### def withFilter(p: (A) ⇒ Boolean): Iterator[A]

   Implicit information
     This member is added by an implicit conversion from Impl[A] to MonadOps[A] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (impl: MonadOps[A]).withFilter(p)

   Definition Classes
     MonadOps

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from IndexedSeq[A]

### Inherited from collection.IndexedSeq[A]

### Inherited from IndexedSeqLike[A, IndexedSeq[A]]

### Inherited from Seq[A]

### Inherited from Iterable[A]

### Inherited from Traversable[A]

### Inherited from Immutable

### Inherited from AbstractSeq[A]

### Inherited from collection.Seq[A]

### Inherited from SeqLike[A, IndexedSeq[A]]

### Inherited from GenSeq[A]

### Inherited from GenSeqLike[A, IndexedSeq[A]]

### Inherited from PartialFunction[Int, A]

### Inherited from (Int) ⇒ A

### Inherited from AbstractIterable[A]

### Inherited from collection.Iterable[A]

### Inherited from IterableLike[A, IndexedSeq[A]]

### Inherited from Equals

### Inherited from GenIterable[A]

### Inherited from GenIterableLike[A, IndexedSeq[A]]

### Inherited from AbstractTraversable[A]

### Inherited from collection.Traversable[A]

### Inherited from GenTraversable[A]

### Inherited from GenericTraversableTemplate[A, IndexedSeq]

### Inherited from TraversableLike[A, IndexedSeq[A]]

### Inherited from GenTraversableLike[A, IndexedSeq[A]]

### Inherited from Parallelizable[A, ParSeq[A]]

### Inherited from TraversableOnce[A]

### Inherited from GenTraversableOnce[A]

### Inherited from FilterMonadic[A, IndexedSeq[A]]

### Inherited from HasNewBuilder[A, scala.collection.immutable.IndexedSeq[A] @scala.annotation.unchecked.uncheckedVariance]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion SeqCharSequence from Impl[A] to SeqCharSequence

### Inherited by implicit conversion CollectionsHaveToParArray from Impl[A] to CollectionsHaveToParArray[Impl[A], T]

### Inherited by implicit conversion MonadOps from Impl[A] to MonadOps[A]

### Inherited by implicit conversion any2stringadd from Impl[A] to any2stringadd[Impl[A]]

### Inherited by implicit conversion StringFormat from Impl[A] to StringFormat[Impl[A]]

### Inherited by implicit conversion Ensuring from Impl[A] to Ensuring[Impl[A]]

### Inherited by implicit conversion ArrowAssoc from Impl[A] to ArrowAssoc[Impl[A]]

### Inherited by implicit conversion alternateImplicit from Impl[A] to ForceImplicitAmbiguity

### Ungrouped